% Rozvoj obdelnikove funkce do Fourierovy rady
% Dana funkce: f(x)=1 pro 0<=x<pi a ft=-1 pro pi<x<=2*pi  
% Rozvoj do Fourierovy rady: g(x)~4/pi*sum ((sin(k*x)/k), k=1,3,5,...

  x=0:.1:2*pi;
  g=4/pi*sin(x);
    figure(1); subplot(1,4,1); plot(x,g); grid on; axis([0 2*pi -1.3 1.3]);
  g=g+4/pi*sin(3*x)/3;
    subplot(1,4,2); plot(x,g); grid on; axis([0 2*pi -1.3 1.3]);
  g=4/pi*(sin(x)+sin(3*x)/3+sin(5*x)/5+sin(7*x)/7+sin(9*x)/9);
    subplot(1,4,4); plot(x,g); grid on; axis([0 2*pi -1.3 1.3]);

  x=0:.02:pi;
  g=zeros(1,length(x));
  for k=1:2:19
    g=g+4/pi*sin(k*x)/k;
    X((k+1)/2,:) = g;
  end

  figure(2);
    plot(x,X(1:2:9,:)'); grid on; axis tight
    title('THE FOURIER EXPANSION OF A SQUARE WAVE: Gibbs'' effect')
  figure(3); mesh(X);
    axis tight ij

  % surf(y); shading interp; axis off ij

% Symbolic solution
  syms t m
  for n=0:9
    f=4/pi*symsum(sin((2*m+1)*t)/(2*m+1),m,0,n);
    figure(4); ezplot(f); grid on
      title(['THE FOURIER EXPANSION OF A SQUARE WAVE, order: ',num2str(n)])
      disp('Press any key to continue'); pause
  end